<?php
/*
Plugin Name: Count Posts in a Category
Plugin URI: http://wikiduh.com/plugins/count-posts-in-a-category
Description: Adds a custom short code that returns the number of posts in a given category.
Version: 1.0
Author: bitacre
Author URI: http://wikiduh.com
Acknowledgements: 
	Thank you to Tim Trott of Azulia Designs (http://azuliadesigns.com) 
	for tutoring me on the fundamentals of WordPress plugin creation.
	
License: GPLv2 
	Copyright 2011 bitacre (plugins@wikiduh.com)
*/

function cat_count_posts($cat=NULL, $type='slug' ) {
	if($type!='slug' || $type!='name' || $type!='id') $type='slug'; // identifier type defaults to 'slug' if missing or malformed
	$categories = get_categories(); // load all categories into array
   	foreach($categories as $category) { // get post counts
		// experimental multi-identifier use
		if($type=='slug') $counter[$category->slug] = $category->count; 
		if($type=='name')$counter[$category->name] = $category->count;
		if($type=='id')$counter[$category->ID] = $category->count;
	}
	if (empty($counter[$cat]) || is_null($counter[$cat])) $count_value=0; // if no such category, return 0
	else $count_value = $counter[$cat];
	return $count_value  ;
}

function cat_count_posts_short( $atts ) {
	extract( shortcode_atts( array( 
	'cat' => NULL, 
	'type' => 'slug',
), $atts ) );
   	if($type!='slug' || $type!='name' || $type!='id') $type='slug'; // identifier type defaults to 'slug' if missing or malformed
	$categories = get_categories(); // load all categories into array
   	foreach($categories as $category) { // get post counts
		if($type=='slug') $counter[$category->slug] = $category->count; 
		if($type=='name')$counter[$category->name] = $category->count;
		if($type=='id')$counter[$category->id] = $category->count;
	}
	if (empty($counter[$cat]) || is_null($counter[$cat])) $count_value=0; // if no such category, return 0
	else $count_value = $counter[$cat];
	return $count_value  ;
}

add_shortcode( 'catcountposts', 'cat_count_posts_short' );

?>